#include "feedback.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <orb/orbit.h>
#include <libgnorba/gnorba.h>
#include <orb/poa.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <gdk/gdkprivate.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <gnome.h>
#include <liboaf/liboaf.h>
#include <glib.h>
#include "feedback-skelimpl.c"

static gint
save_session (GnomeClient *client, gint phase, GnomeSaveStyle save_style,
		gint is_shutdown, GnomeInteractStyle interact_style,
		gint is_fast, gpointer client_data);

int main(int argc, char** argv)
{
	CORBA_ORB orb;
	CORBA_Environment ev;
	PortableServer_POA root_poa, poa;
	PortableServer_POAManager root_poa_manager;
	CORBA_PolicyList policy_list = {0, 0, NULL};
	Feedback feedback = CORBA_OBJECT_NIL;
	GnomeClient *client=NULL;
	gchar *ior;
	FILE *ofp;
	GdkWindow *root_win;

	CORBA_exception_init(&ev);

	/*Problems with OAF, using an IOR for the moment.
	gnome_init_with_popt_table("feedback_server", "0.0", argc, argv, oaf_popt_options, 0, NULL);
	orb = oaf_init(argc, argv);*/

	orb = gnome_CORBA_init("Feedback", "v 1.0", &argc, argv, GNORBA_INIT_SERVER_FUNC, &ev);

	if (ev._major != CORBA_NO_EXCEPTION) {
		fprintf(stderr, "Error: exception during servant initialisation: %s\n", 
			CORBA_exception_id(&ev));
		CORBA_exception_free(&ev);
		exit(1);
	}

	
	root_poa=(PortableServer_POA)CORBA_ORB_resolve_initial_references(orb, "RootPOA", &ev);
        root_poa_manager= (PortableServer_POAManager)PortableServer_POA__get_the_POAManager(root_poa, &ev);
	PortableServer_POAManager_activate(root_poa_manager, &ev);
	PortableServer_POA_create_POA(root_poa, "feedback_poa", root_poa_manager, &policy_list, &ev);
	poa = (PortableServer_POA)PortableServer_POA_find_POA (root_poa, "feedback_poa", TRUE, &ev);
	if (ev._major != CORBA_NO_EXCEPTION) {
		fprintf(stderr, "Error: exception during POA initialisation: %s\n", 
				CORBA_exception_id(&ev));
		CORBA_exception_free(&ev);
		exit(1);
	}

	feedback=impl_Feedback__create(poa, &ev);
        if (!feedback){
		fprintf(stderr, "Error: cannot get object reference\n");
		exit(1);
	}
	 ior=CORBA_ORB_object_to_string(orb, feedback, &ev);
	 ofp = fopen("feedback.ior", "w");
	 fprintf(ofp, "%s", ior);
	 printf("ior is %s\n", ior);
	 fclose(ofp);

	/*oaf_active_server_register("OAFIID:Feedback:afd9e479-24b6-4c24-8945-168da0cd01b0", feedback);*/
	 root_win=gdk_window_lookup(GDK_ROOT_WINDOW());

        client=gnome_master_client();
	gtk_signal_connect(GTK_OBJECT(client), "save_yourself",
				GTK_SIGNAL_FUNC(save_session), NULL);
	gtk_main();

	/*oaf_active_server_unregister("OAFIID:Feedback:afd9e479-24b6-4c24-8945-168da0cd01b0", feedback);*/

	impl_Feedback__destroy((impl_POA_Feedback *)&feedback, &ev);
        CORBA_Object_release((CORBA_Object)root_poa, &ev);
	CORBA_exception_free(&ev);
	return 0;
	

	
}	

static gint
save_session (GnomeClient *client, gint phase, GnomeSaveStyle save_style,
		gint is_shutdown, GnomeInteractStyle interact_style,
		gint is_fast, gpointer client_data)
{
	return TRUE;
}
